function OnHTMLDataGridRowSelect(cVar, rowData, rowNumber) 
{
   var grid = eval(cVar);
   grid.editRow(rowData, rowNumber);
}

function OnHTMLDataGridCellSelect(cVar, rowNumber, colNumber) 
{
   var grid = eval(cVar);
   grid.editCell(rowData, rowNumber);
}

function OnHTMLDataGridDataChange(cVar) { eval(cVar + ".writeObjHTML()");}

function escapeArray ( valArray )
{
	var valueList = new Array();

   for ( n = 0; n < valArray.length; n++ )
   {
      valueList[n] = escape(valArray[n]);
   }

   return valueList;
}

function OnHTMLDataGridLinkClick(hRef)
{
	window.open(hRef);
}

function HTMLDataGrid2(controlVariable, frameDiv, initialData)
{
    //  Standard stuff
    this.ctrlVar = controlVariable;
    this.container = frameDiv;
    this.objHTML = buildTable;
    this.writeObjHTML = writeTable;

    //  Display Properties
	 this.headingData = new Array();
    this.arrayData = (initialData) ? initialData : new Array();
	 this.rowHeight = 30;
    this.bShowHeading = false;
    this.bNamedFirstColumn = false;
    this.bNumberRows = true;
	 this.border = 1;

	 // State Properties
	 this.maxRows = 1;
	 this.pages = 1;
	 this.currentPage = 0;
	 this.currentRow = new Array();

    // Methods
    this.addRow = addDataRow;
	 this.editRow = editDataRow;
    this.updateRow = updateDataRow;
    this.deleteRow = deleteDataRow;
    this.addHeading = addHeadingRow;
	 this.nextPage = nextDataPage;
	 this.prevPage = prevDataPage;

	 //New Properties
	 this.rowSelect = true;
	 this.colSelect = false;

	 //New Methods
    this.getValue = returnGridValue;
    this.setValue = updateGridValue;
	 this.highlightRow = highlightRow;
	 this.highlightCol = highlightCol;
	 this.highlightCell = highlightCell;
	 this.editCell = editCell;
	 this.catchKeys = catchKeys;

	 function highlightRow(rowNum)
	 {
		 var gridT = document.all["gridTable"];
		 gridT.rows[rowNum].style.backgroundColor = "red";
	 }

	 function highlightCol(colNum)
	 {
		 var gridT = document.all["gridTable"];

		 for (num = 0; num < gridT.rows.length; num++) 
		 {
			 gridT.rows[num].cells[colNum].style.backgroundColor = "red";
		 }
	 }

	 function highlightCell(rowNum, colNum)
	 {
		 var gridT = document.all["gridTable"];

		 gridT.rows[rowNum].cells[colNum].style.backgroundColor = "red";
	 }
    
	 function returnGridValue(x, y)
    {
       return this.arrayData[x][y];   
    }

    function updateGridValue(x, y, newValue)
    {
       this.arrayData[x][y] = newValue;   
       OnHTMLDataGridDataChange(this.ctrlVar);
    }
	 
	 function editCell(rowNum, colNum)
	 {
		 if (!document.all["editCell"]) 
		 {
			var gridT = document.all["gridTable"];

			gridT.rows[rowNum].cells[colNum].innerHTML = "<input name=editCell id=editCell type=text onkeypress='"
																  + this.ctrlVar 
																  + ".catchKeys(" + rowNum + "," + colNum + ")'"
																  + " value=\"" + unescape(this.arrayData[rowNum-1][colNum-1]) + "\">";
		 }

		 document.all["editCell"].focus();
	 }
    
	 function catchKeys(rowNum, colNum)
	 {
 		if (event.keyCode == 13) 
		{
			var gridT = document.all["gridTable"];
			gridT.rows[rowNum].cells[colNum].innerHTML = event.srcElement.value;
			this.arrayData[rowNum-1][colNum-1] = escape(event.srcElement.value);
		}
	 }

	 parseLink(lText)
	 {
		if (lText.indexOf("<A") != -1)
		{
			var arLink = lText.split("href=");
			var hrefText = arLink[1].substr(arLink[1].indexOf(" "));
			var lIdx = arLink[1].indexOf(">");
			return "<a href=javascript:OnHTMLDataGridLinkClick('" + hrefText
				    + "')>" + link[1].substring(lIdx);
		}
		else return lText;
	 }

	 function writeTable()
	 {
  		document.all[this.container].innerHTML = this.objHTML();
	 }

    function buildTable()
    {
		 //this.maxRows = Math.floor(document.all[this.container].offsetHeight/this.rowHeight);
		 this.pages = Math.ceil(this.arrayData.length / this.maxRows);
		 
		 this.currentPage = Math.max(this.currentPage, 0);
		 this.currentPage = Math.min(this.currentPage, this.pages-1);

		 var numRows = (this.currentPage != this.pages-1) ? this.maxRows :
								         this.arrayData.length % this.maxRows;

		 var tableHTML = new String("<TABLE id=gridTable border=" + this.border + ">");
      
		 if (this.bShowHeading)
		 {
			tableHTML += "<tr>";
			if (this.bNumberRows) tableHTML += "<th>#</th>";
			for (i2 = 0; i2 < this.headingData.length; i2++)
			{
				 tableHTML += "<th>" + this.headingData[i2] + "</th>";
			}
			tableHTML += "</tr>";
		 }
		 
		 if (this.currentRow.length > 0)
		 {
			tableHTML += "<tr>";
			if (this.bNumberRows) tableHTML += "<td>" + this.currentRow[0] + "</td>";
			for (i2 = 1; i2 < this.currentRow.length; i2++)
			{
				 tableHTML += "<td>" + this.currentRow[i2] + "</td>";
			}
			tableHTML += "</tr>";
		 }
		 
		 var startRow = this.maxRows*this.currentPage;

		 for (i = startRow; i < startRow+numRows; i++)
       {
          if (this.arrayData[i].length > 1)
          {
            
          }

			 tableHTML += "<tr onclick=\"OnHTMLDataGridRowSelect('" + this.ctrlVar + "', '" + escapeArray(this.arrayData[i]) + "'," + (i+1) + ");\">";
			 if (this.bNumberRows) tableHTML += "<td>" + (i+1) + "</td>";

          for (i2 = 0; i2 < this.arrayData[i].length; i2++)
          {
             tableHTML += "<td onclick=\"OnHTMLDataGridCellSelect('" + this.ctrlVar + "', " + (i-startRow+1) + ", " + (i2+1) + ")\">" + this.arrayData[i][i2] + "</td>";
          }

			 tableHTML += "</tr>";
       }

		 return tableHTML + "</table>";
    }

    function addDataRow(arRow) 
	 {
  		this.arrayData[this.arrayData.length] = arRow;
		OnHTMLDataGridDataChange(this.ctrlVar);
	 }

	 function editDataRow(rowData, rowNumber)
	 {
       this.currentRow = new Array();

		 arData = rowData.split(",");  
		 this.currentRow[0] = rowNumber;

		 for (x2=0; x2 < arData.length; x2++) 
		 {
          this.currentRow[x2+1] = "<input id=currentRow" + x2 + " value=\"" + unescape(arData[x2]) + "\">";
		 }
		 

       this.currentRow[this.currentRow.length] = "<input type=button id=btnRow value='Update' onclick='" 
			                        + this.ctrlVar + ".updateRow(" + rowNumber + ")'>";
       
       OnHTMLDataGridDataChange(this.ctrlVar);
	 }

    function updateDataRow(rowNumber, arRow) 
	 {
		 if (arguments.length == 1) 
		 {
			 arRow = new Array();
			 var eCount = 0;
  			
			 while (document.all["currentRow" + eCount]) 
			 {
				arRow[eCount] = document.all["currentRow" + eCount].value;
				eCount++;
			 }

			 this.currentRow = new Array();
		 }

		 this.arrayData[rowNumber] = arRow;
		 OnHTMLDataGridDataChange(this.ctrlVar);
	 }

    function deleteDataRow(rowNumber) {}

    function addHeadingRow(arRow) 
	 { 
		 this.bShowHeading = true; 
		this.headingData = arRow;		
	 }

	 function nextDataPage(z)
	 {
		this.currentPage = (arguments.length == 1) ? z : ++this.currentPage;
		OnHTMLDataGridDataChange(this.ctrlVar);
	 }
	 
	 function prevDataPage(z)
	 {
		 this.currentPage = (arguments.length == 1) ? z : --this.currentPage;
		 OnHTMLDataGridDataChange(this.ctrlVar);
	 }
}
